using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_user_delegated_permission")]
    public class SecurityUserDelegatedPermissionEntity : EntityBase<SecurityUserDelegatedPermissionEntityKey>
    {

    public SecurityUserDelegatedPermissionEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Column("user_name")]
    public string UserName  { get; set; }
    [Column("delegated_by_user")]
    public string DelegatedByUser  { get; set; }
    [Column("permission_name")]
    public string PermissionName  { get; set; }
    [Column("start_datetime")]
    public DateTime StartDatetime  { get; set; }
    [Column("end_datetime")]
    public DateTime EndDatetime  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string USER_NAME = "UserName";
    public const string DELEGATED_BY_USER = "DelegatedByUser";
    public const string PERMISSION_NAME = "PermissionName";
    public const string START_DATETIME = "StartDatetime";
    public const string END_DATETIME = "EndDatetime";

    public const string DB_NAME_SECURITY_USER_DELEGATED_PERMISSION = "security_user_delegated_permission";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,user_name,delegated_by_user,permission_name,start_datetime,end_datetime";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_USER_NAME = "user_name";
    public const string DB_DELEGATED_BY_USER = "delegated_by_user";
    public const string DB_PERMISSION_NAME = "permission_name";
    public const string DB_START_DATETIME = "start_datetime";
    public const string DB_END_DATETIME = "end_datetime";


    public static SecurityUserDelegatedPermissionEntity GetInstance()
    {
        return new SecurityUserDelegatedPermissionEntity();
    }

    public virtual void CopyFrom(SecurityUserDelegatedPermissionEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityUserDelegatedPermissionEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.UserName =  source.UserName;
        this.DelegatedByUser =  source.DelegatedByUser;
        this.PermissionName =  source.PermissionName;
        this.StartDatetime =  source.StartDatetime;
        this.EndDatetime =  source.EndDatetime;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_USER_DELEGATED_PERMISSION}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_USER_DELEGATED_PERMISSION}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_USER_NAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_USER_DELEGATED_PERMISSION}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityUserDelegatedPermissionEntity Clone()
    {
        SecurityUserDelegatedPermissionEntity result = new SecurityUserDelegatedPermissionEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
